
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Inventory_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.create(
            {
                id: data.id || undefined,
        
        warehouse_name: data.warehouse_name
        ||
        null
            ,
            
        on_hand_cases: data.on_hand_cases
        ||
        null
            ,
            
        allocated_cases: data.allocated_cases
        ||
        null
            ,
            
        available_cases: data.available_cases
        ||
        null
            ,
            
        last_sync_at: data.last_sync_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await inventory_items.setProduct( data.product || null, {
            transaction,
        });
        

        

        

        return inventory_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const inventory_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                warehouse_name: item.warehouse_name
            ||
            null
            ,
            
                on_hand_cases: item.on_hand_cases
            ||
            null
            ,
            
                allocated_cases: item.allocated_cases
            ||
            null
            ,
            
                available_cases: item.available_cases
            ||
            null
            ,
            
                last_sync_at: item.last_sync_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const inventory_items = await db.inventory_items.bulkCreate(inventory_itemsData, { transaction });

        // For each item created, replace relation files
        

        return inventory_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const inventory_items = await db.inventory_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.warehouse_name !== undefined) updatePayload.warehouse_name = data.warehouse_name;
        
        
        if (data.on_hand_cases !== undefined) updatePayload.on_hand_cases = data.on_hand_cases;
        
        
        if (data.allocated_cases !== undefined) updatePayload.allocated_cases = data.allocated_cases;
        
        
        if (data.available_cases !== undefined) updatePayload.available_cases = data.available_cases;
        
        
        if (data.last_sync_at !== undefined) updatePayload.last_sync_at = data.last_sync_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await inventory_items.update(updatePayload, {transaction});

        
        
        if (data.product !== undefined) {
            await inventory_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        

        
        

        

        return inventory_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of inventory_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of inventory_items) {
                await record.destroy({transaction});
            }
        });


        return inventory_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findByPk(id, options);

        await inventory_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await inventory_items.destroy({
            transaction
        });

        return inventory_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const inventory_items = await db.inventory_items.findOne(
            { where },
            { transaction },
        );

        if (!inventory_items) {
            return inventory_items;
        }

        const output = inventory_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.product = await inventory_items.getProduct({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.warehouse_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'inventory_items',
                        'warehouse_name',
                        filter.warehouse_name,
                    ),
                };
            }
            

            
            

            
            if (filter.on_hand_casesRange) {
                const [start, end] = filter.on_hand_casesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    on_hand_cases: {
                    ...where.on_hand_cases,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    on_hand_cases: {
                    ...where.on_hand_cases,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.allocated_casesRange) {
                const [start, end] = filter.allocated_casesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    allocated_cases: {
                    ...where.allocated_cases,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    allocated_cases: {
                    ...where.allocated_cases,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.available_casesRange) {
                const [start, end] = filter.available_casesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    available_cases: {
                    ...where.available_cases,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    available_cases: {
                    ...where.available_cases,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_sync_atRange) {
                const [start, end] = filter.last_sync_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_sync_at: {
                    ...where.last_sync_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_sync_at: {
                    ...where.last_sync_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.inventory_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'inventory_items',
                        'warehouse_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.inventory_items.findAll({
            attributes: [ 'id', 'warehouse_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['warehouse_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.warehouse_name,
        }));
    }

    
};

